<?php

namespace Pinpoint\TestimonialManager\Block\TestimonialArea;

use Magento\Framework\View\Element\Template;

/**
 * Class Area
 * @package Pinpoint\TestimonialManager\Block\TestimonialArea
 */
class Area extends Template
{
    /**
     * @var string $_template
     */
    protected $_template = "Pinpoint_TestimonialManager::render.phtml";

    /**
     * @var $this
     */
    protected $testimonialArea;

    /**
     * @var \Pinpoint\TestimonialManager\Model\Testimonial
     */
    protected $testimonial;

    /**
     * Area constructor.
     * @param Template\Context $context
     * @param \Pinpoint\TestimonialManager\Model\TestimonialArea $testimonialArea
     * @param \Pinpoint\TestimonialManager\Model\Testimonial $testimonial
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        \Pinpoint\TestimonialManager\Model\TestimonialArea $testimonialArea,
        \Pinpoint\TestimonialManager\Model\Testimonial $testimonial,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->testimonialArea = $testimonialArea->load($this->getData('area_id'));
        $this->testimonial = $testimonial;
    }

    /**
     * @return \Magento\Framework\DataObject[]
     */
    public function getTestimonials()
    {
        $collection = $this->testimonial->getCollection()
            ->addFieldToFilter(
                'id',
                ['in' => explode(',', $this->testimonialArea->getData('testimonials'))]
            );
        if ((int)$this->testimonialArea->getData('randomise')) {
            $collection->getSelect()->orderRand();
        }

        return $collection->getItems();
    }
}