<?php
namespace Pinpoint\TestimonialManager\Controller\Adminhtml\Testimonials;

use Magento\Backend\App\Action;

/**
 * Class Delete
 * @package Pinpoint\TestimonialManager\Controller\Adminhtml\Testimonials
 */
class Delete extends \Magento\Backend\App\Action
{
    /**
     * @var string
     */
    const ADMIN_RESOURCE = 'Pinpoint_TestimonialManager::addedit';

    /**
     * @var \Pinpoint\TestimonialManager\Model\Testimonial
     */
    protected $testimonial;

    /**
     * Delete constructor.
     * @param Action\Context $context
     * @param \Pinpoint\TestimonialManager\Model\Testimonial $testimonial
     */
    public function __construct(
      Action\Context $context,
      \Pinpoint\TestimonialManager\Model\Testimonial $testimonial
    ) {
        $this->testimonial = $testimonial;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Backend\Model\View\Result\Redirect
     */
    public function execute()
    {
        // check if we know what should be deleted
        $id = $this->getRequest()->getParam('id');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            try {
                // init model and delete
                $model = $this->testimonial;
                $model->load($id);
                $model->delete();
                // display success message
                $this->messageManager->addSuccess(__('Testimonial has been deleted.'));
                // go to grid
                return $resultRedirect->setPath('*/*/list');
            } catch (\Exception $e) {
                // display error message
                $this->messageManager->addError($e->getMessage());
                // go back to edit form
                return $resultRedirect->setPath('*/*/edit', ['id' => $id]);
            }
        }
        // display error message
        $this->messageManager->addError(__('We can not find an object to delete.'));
        // go to grid
        return $resultRedirect->setPath('*/*/list');
    }    
    
}
