<?php
namespace Pinpoint\TestimonialManager\Ui\Component\Listing\DataProviders\Pinpoint\Testimonialmanager;

/**
 * Class Areas
 * @package Pinpoint\TestimonialManager\Ui\Component\Listing\DataProviders\Pinpoint\Testimonialmanager
 */
class Areas extends \Magento\Ui\DataProvider\AbstractDataProvider
{
    /**
     * Areas constructor.
     * @param string $name
     * @param string $primaryFieldName
     * @param string $requestFieldName
     * @param \Pinpoint\TestimonialManager\Model\ResourceModel\TestimonialArea\CollectionFactory $collectionFactory
     * @param array $meta
     * @param array $data
     */
    public function __construct(
        $name,
        $primaryFieldName,
        $requestFieldName,
        \Pinpoint\TestimonialManager\Model\ResourceModel\TestimonialArea\CollectionFactory $collectionFactory,
        array $meta = [],
        array $data = []
    ) {
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
        $this->collection = $collectionFactory->create();
    }

    /**
     * @return array
     */
    public function getData()
    {
        $areas = parent::getData();
        $i = 0;
        foreach ($areas['items'] as $area) {
            $areas['items'][$i]['testimonial_total'] = count(array_filter(explode(",", $area['testimonials'])));
            $i++;
        }
        return $areas;
    }
}
