<?php
namespace Pinpoint\TestimonialManager\Ui\Component\Listing\DataProviders\Pinpoint\Testimonialmanager;

/**
 * Class Testimonials
 * @package Pinpoint\TestimonialManager\Ui\Component\Listing\DataProviders\Pinpoint\Testimonialmanager
 */
class Testimonials extends \Magento\Ui\DataProvider\AbstractDataProvider
{
    /**
     * @var \Pinpoint\TestimonialManager\Model\TestimonialArea
     */
    protected $testimonialArea;

    /**
     * @var \Magento\Framework\App\Request\Http
     */
    protected $request;

    /**
     * Testimonials constructor.
     * @param string $name
     * @param string $primaryFieldName
     * @param string $requestFieldName
     * @param \Pinpoint\TestimonialManager\Model\ResourceModel\Testimonial\CollectionFactory $collectionFactory
     * @param \Pinpoint\TestimonialManager\Model\TestimonialArea $testimonialArea
     * @param \Magento\Framework\App\Request\Http $request
     * @param array $meta
     * @param array $data
     */
    public function __construct(
        $name,
        $primaryFieldName,
        $requestFieldName,
        \Pinpoint\TestimonialManager\Model\ResourceModel\Testimonial\CollectionFactory $collectionFactory,
        \Pinpoint\TestimonialManager\Model\TestimonialArea $testimonialArea,
        \Magento\Framework\App\Request\Http $request,
        array $meta = [],
        array $data = []
    ) {
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
        $this->collection = $collectionFactory->create();
        $this->testimonialArea = $testimonialArea;
        $this->request = $request;
    }
}
